
Imports System.IO
Imports System.Data
Imports System.Collections.Generic
Imports ClosedXML.Excel

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub ImportExcel(sender As Object, e As EventArgs)
        'Open the Excel file using ClosedXML.
        Using workBook As New XLWorkbook(FileUpload1.PostedFile.InputStream)
            'Read the first Sheet from Excel file.
            Dim workSheet As IXLWorksheet = workBook.Worksheet(1)

            'Create a new DataTable.
            Dim dt As New DataTable()

            'Loop through the Worksheet rows.
            Dim firstRow As Boolean = True
            For Each row As IXLRow In workSheet.Rows()
                'Use the first row to add columns to DataTable.
                If firstRow Then
                    For Each cell As IXLCell In row.Cells()
                        dt.Columns.Add(cell.Value.ToString())
                    Next
                    firstRow = False
                Else
                    'Add rows to DataTable.
                    dt.Rows.Add()
                    Dim i As Integer = 0
                    For Each cell As IXLCell In row.Cells()
                        dt.Rows(dt.Rows.Count - 1)(i) = cell.Value.ToString()
                        i += 1
                    Next
                End If

                GridView1.DataSource = dt
                GridView1.DataBind()
            Next
        End Using
    End Sub
End Class

